/**
 * A generic helper for syntax highlighting (see also `nanolightJs`).
 */
export const nanolight = (
  /** @type {RegExp} */ pattern,
  /** @type {((chunk: string, index: number) => import('./h.js').HArgs)[]} */ highlighters,
  /** @type {string} */ code
) => {
  const /** @type {import('./h.js').HArgs[]} */ result = []

  code.split(pattern).forEach((chunk, index) => {
    index %= highlighters.length
    if (chunk != null) {
      result.push(highlighters[index](chunk, index))
    }
  })

  return result
}

export const /** @type {Record<string, () => void>} */ tests = {}
