import { h } from './h.js'
import { nanolight } from './nanolight.js'

/**
 * A helper for highlighting JavaScript.
 */
// @ts-expect-error
export const nanolightJs = nanolight.bind(0,
  /('.*?'|".*?"|`[\s\S]*?`)|(\/\/.*?\n|\/\*[\s\S]*?\*\/)|(break|case|catch|const|continue|debugger|default|delete|do|else|eval|export\s+type|export|extends|false|finally|for|from|function|goto|if|import|in|instanceof|is|keyof|let|NaN|new|null|package|return|super|switch|this|throw|true|try|typeof|undefined|var|void|while|with|yield)(?!\w)|([<>=.?:&|!~*/%+-])|(0x[\dabcdef]+|0o[01234567]+|0b[01]+|\d+(?:\.[\d_]+)?(?:e[+-]?[\d_]+)?)|([$\w]+)(?=\()|([$\wąćęłńóśżźĄĆĘŁŃÓŚŻŹ]+)/,
  [
    chunk => chunk, // no match
    chunk => ['u', chunk], // string literals
    chunk => ['em', chunk], // comments
    chunk => ['b', chunk], // keywords
    chunk => ['b', chunk], // operators
    chunk => ['u', chunk], // number literals
    chunk => ['ins', chunk], // function calls
    chunk => ['i', chunk] // literals
  ]
)

export const /** @type {Record<string, () => void>} */ tests = {
  nanolightJs: () => {
    const codeJs = 'const answerToLifeTheUniverseAndEverything = 42'

    console.assert(h('pre', ['code', ...nanolightJs(codeJs)]).outerHTML ===
      '<pre><code><b>const</b> <i>answerToLifeTheUniverseAndEverything</i> <b>=</b> <u>42</u></code></pre>')
  }
}
